
const string baseurl = "http://areyeses.ddns.net:3000/api/bot";
const string mapurl = baseurl + "/map";
const string preauthurl = baseurl + "/preauth";
const string authurl = baseurl + "/auth";

// check that the login is valid with my server before verifying user with Openplanet
Status preAuth() {
    CGameCtnApp@ app = GetApp();
    Json::Value@ body = Json::Object();
    body['login'] = app.LocalPlayerInfo.Login;
    Net::HttpRequest@ req = Net::HttpPost(preauthurl, Json::Write(body), 'application/json');
    req.Start();
    while (!req.Finished()) {yield();}
    if (req.ResponseCode() == 403) {
        UI::ShowNotification(Meta::ExecutingPlugin().Name, 'You are not registered as a valid streamer. If you believe this is wrong, contact @ArEyeses on discord', vec4(0.5f, 0.5f, 0.f, 0.5f));
        print('Invalid login');
        return Status::NotStreamer;
    } else if (req.ResponseCode() == 0) {
        if ((repeatConnectionNotification || !shownConnectionNotification) && !hideNotifications) {
            shownConnectionNotification = true;
            UI::ShowNotification(Meta::ExecutingPlugin().Name, 'Failed to connect to server (retry in ' + int(retryConnectionWait/60000) + 'min)', vec4(0.5f, 0.f, 0.f, 0.5f));
        }
        print('Failed to connect to server');
        return Status::NoConnection;
    }
    return Status::Streamer;
}

// use Openplanet's auth system to verify the user is who they say they are, and recieve a session token
Status authWithServer(bool isRetry = false) {
    CGameCtnApp@ app = GetApp();
    Json::Value@ body = Json::Object();
    Auth::PluginAuthTask@ task = Auth::GetToken();
    while (!task.Finished()) {yield();}
    body['authtoken'] = task.Token();
    if (body['authtoken'] == "") {
        if ((repeatConnectionNotification || !shownConnectionNotification) && !hideNotifications) {
            shownConnectionNotification = true;
            UI::ShowNotification(Meta::ExecutingPlugin().Name, 'Failed to connect to Openplanet for token (retry in ' + int(retryConnectionWait/60000) + 'min)', vec4(0.5f, 0.f, 0.f, 0.5f));
        }
        print('Invalid response from Openplanet for token');
        if (!isRetry) {
            notifyOpenplanetDown();
        }
        return Status::NoConnection;
    }
    body['login'] = app.LocalPlayerInfo.Login;
    // body['id'] = app.LocalPlayerInfo.WebServicesUserId;
    Net::HttpRequest@ req = Net::HttpPost(authurl, Json::Write(body), 'application/json');
    req.Start();
    while (!req.Finished()) {yield();}
    if (req.ResponseCode() == 403) {
        print('Invalid login (but didn\'t fail on preauth YEK)');
        return Status::NotStreamer;
    } else if (req.ResponseCode() == 0) {
        if ((repeatConnectionNotification || !shownConnectionNotification) && !hideNotifications) {
            shownConnectionNotification = true;
            UI::ShowNotification(Meta::ExecutingPlugin().Name, 'Failed to connect to server (retry in ' + int(retryConnectionWait/60000) + 'min)', vec4(0.5f, 0.f, 0.f, 0.5f));
        }
        print('Failed to connect to server');
        return Status::NoConnection;
    }
    if (req.ResponseCode() != 200 || req.String().Length == 0) {
        if ((repeatConnectionNotification || !shownConnectionNotification) && !hideNotifications) {
            shownConnectionNotification = true;
            UI::ShowNotification(Meta::ExecutingPlugin().Name, "Invalid repsonse from server", vec4(0.5f, 0.f, 0.f, 0.5f));
        }
        print("" + req.ResponseCode() + ', ' + req.String());
        return Status::NoConnection;
    }
    Json::Value@ response = Json::Parse(req.String());
    sessionToken = response['sessiontoken'];
    trace('authenticated with server');
    if (!hideNotifications) {
        UI::ShowNotification(Meta::ExecutingPlugin().Name, "Authenticated with server. Your played maps will be shared", vec4(0.f, 0.5f, 0.f, 0.5f));
    }
    return Status::Streamer;
}

// send each map to the server along with the valid session token
bool sendToServer(Json::Value@ mapdata) {
    Net::HttpRequest@ req = Net::HttpPost(mapurl, Json::Write(mapdata), 'application/json');
    while (!req.Finished()) {yield();}
    if (req.ResponseCode() == 200) {
        // req is fine (do nothing)
    } else if (req.ResponseCode() == 403) {
        // maybe something has happened to the server since we started TM, so retry auth once
        print('invalid token despite working earlier');
        return false;
    } else {
        print('Failed to send to server (ignoring until next map)');
        // don't return since we already have a token, if server is down just skip this map and try the next one
    }
    return true;
}

void notifyOpenplanetDown() {
    CGameCtnApp@ app = GetApp();
    Json::Value@ body = Json::Object();
    body['login'] = app.LocalPlayerInfo.Login;
    Net::HttpRequest@ req = Net::HttpPost(baseurl + '/openplanetdown', Json::Write(body), 'application/json');
    while (!req.Finished()) {yield();}
    if (req.ResponseCode() == 200 and req.String().Length > 0) {
        Json::Value@ response = Json::Parse(req.String());
        if (bool(response['up']) == true) {
            authWithServer(true);
        }
    }
}
